clear all; clc; close all;

cd(fileparts(mfilename('fullpath')))
currdir = pwd;
RT_allow = 0.3;
plotit = 0;

% excluding SED09 and SED11, who only completed 1 testing session
subjIDs = ['01';'02';'03';'04';'05';'06';'07';'08';'10';'12';'13';'14';'15';'16';'17';'18';'19';'20';'21';'22';'23';'24';'25';'26';'27';];

% for duration analyses
le_block = cell(13,size(subjIDs,1),2); re_block = cell(13,size(subjIDs,1),2); be_block = cell(13,size(subjIDs,1),2);
trial_durs = zeros(13,size(subjIDs,1),2);

locationorder = zeros(26,size(subjIDs,1),2);
configorder = zeros(26,size(subjIDs,1),2);
for SJ = 1:size(subjIDs,1)
    
    %% first analyze first run for each subject
    eyecount_RUN1 = zeros(3,13); eyecount_RUN2 = zeros(3,13);
    
    eval(['load ', currdir, '/Data_Maps_SED', subjIDs(SJ,:)]);
    locationorder(:,SJ,1) = MapsData{1}.params.locorder;
    
    if SJ == 15 % this subject, after run 1, told us that he had been pressing left arrow for red and right arrow for green, the opposite of what all other subjects did.
        LEkey = -1;
        REkey = 1;
    else
        LEkey = 1;
        REkey = -1;
    end
    
    for i = 1:length(MapsData)
        trial_durs(locationorder(i,SJ,1),SJ,1) = trial_durs(locationorder(i,SJ,1),SJ,1) + 60 + MapsData{i}.overtime;
        for n = 1:size(MapsData{i}.Times,1)-1
            if MapsData{i}.Times(n,3) == LEkey
                if (MapsData{i}.Times(n+1,1)-MapsData{i}.Times(n,1)) > RT_allow
                    le_block{locationorder(i,SJ,1),SJ,1}(eyecount_RUN1(1,locationorder(i,SJ,1))+1) = MapsData{i}.Times(n+1,1)-MapsData{i}.Times(n,1);
                    eyecount_RUN1(1,locationorder(i,SJ,1)) = eyecount_RUN1(1,locationorder(i,SJ,1)) + 1;
                end
            elseif MapsData{i}.Times(n,3) == REkey
                if (MapsData{i}.Times(n+1,1)-MapsData{i}.Times(n,1)) > RT_allow
                    re_block{locationorder(i,SJ,1),SJ,1}(eyecount_RUN1(2,locationorder(i,SJ,1))+1) = MapsData{i}.Times(n+1,1)-MapsData{i}.Times(n,1);
                    eyecount_RUN1(2,locationorder(i,SJ,1)) = eyecount_RUN1(2,locationorder(i,SJ,1))+1;
                end
            elseif MapsData{i}.Times(n,3) == 0
                if (MapsData{i}.Times(n+1,1)-MapsData{i}.Times(n,1)) > RT_allow
                    be_block{locationorder(i,SJ,1),SJ,1}(eyecount_RUN1(3,locationorder(i,SJ,1))+1) = MapsData{i}.Times(n+1,1)-MapsData{i}.Times(n,1);
                    eyecount_RUN1(3,locationorder(i,SJ,1)) = eyecount_RUN1(3,locationorder(i,SJ,1))+1;
                end
            end
        end
    end
    clear MapsData
    
    %% repeat analysis for run 2
    eval(['load ', currdir, '/Data_Maps_SED', subjIDs(SJ,:), '_2']);
    
    locationorder(:,SJ,2) = MapsData{1}.params.locorder;
    
    LEkey = 1;
    REkey = -1;
    
    for i = 1:length(MapsData)
        trial_durs(locationorder(i,SJ,2),SJ,2) = trial_durs(locationorder(i,SJ,2),SJ,2) + 60 + MapsData{i}.overtime;
        configorder(i,SJ,2) = MapsData{i}.config;
        for n = 1:size(MapsData{i}.Times,1)-1
            % block by block analysis
            if MapsData{i}.Times(n,3) == LEkey
                if (MapsData{i}.Times(n+1,1)-MapsData{i}.Times(n,1)) > RT_allow
                    le_block{locationorder(i,SJ,2),SJ,2}(eyecount_RUN2(1,locationorder(i,SJ,2))+1) = MapsData{i}.Times(n+1,1)-MapsData{i}.Times(n,1);
                    eyecount_RUN2(1,locationorder(i,SJ,2)) = eyecount_RUN2(1,locationorder(i,SJ,2))+1;
                end
            elseif MapsData{i}.Times(n,3) == REkey
                if (MapsData{i}.Times(n+1,1)-MapsData{i}.Times(n,1)) > RT_allow
                    re_block{locationorder(i,SJ,2),SJ,2}(eyecount_RUN2(2,locationorder(i,SJ,2))+1) = MapsData{i}.Times(n+1,1)-MapsData{i}.Times(n,1);
                    eyecount_RUN2(2,locationorder(i,SJ,2)) = eyecount_RUN2(2,locationorder(i,SJ,2))+1;
                end
            elseif MapsData{i}.Times(n,3) == 0
                if (MapsData{i}.Times(n+1,1)-MapsData{i}.Times(n,1)) > RT_allow
                    be_block{locationorder(i,SJ,2),SJ,2}(eyecount_RUN2(3,locationorder(i,SJ,2))+1) = MapsData{i}.Times(n+1,1)-MapsData{i}.Times(n,1);
                    eyecount_RUN2(3,locationorder(i,SJ,2)) = eyecount_RUN2(3,locationorder(i,SJ,2))+1;
                end
            end
        end
    end
    
    clear MapsData
end

%% now compute SED
SED_run = zeros(13,size(subjIDs,1),2);
STIM_run = zeros(13,size(subjIDs,1),2);
for SJ = 1:size(subjIDs,1)
    % first run 1
    for i = 1:13
        propLE1(i,SJ) = nansum(le_block{i,SJ,1})/(nansum(le_block{i,SJ,1}) + nansum(re_block{i,SJ,1}) + nansum(be_block{i,SJ,1}));
        propRE1(i,SJ) = nansum(re_block{i,SJ,1})/(nansum(le_block{i,SJ,1}) + nansum(re_block{i,SJ,1}) + nansum(be_block{i,SJ,1}));
        propBE1(i,SJ) = nansum(be_block{i,SJ,1})/(nansum(le_block{i,SJ,1}) + nansum(re_block{i,SJ,1}) + nansum(be_block{i,SJ,1}));
        
        % now RE-LE/RE+LE, after Dieter, Sy & Blake Vis Res submission
        SED_run(i,SJ,1) = (propRE1(i,SJ)-propLE1(i,SJ))/(propRE1(i,SJ)+propLE1(i,SJ));
    end
    
    % now run 2
    for i = 1:13
        propLE2(i,SJ) = nansum(le_block{i,SJ,2})/(nansum(le_block{i,SJ,2}) + nansum(re_block{i,SJ,2}) + nansum(be_block{i,SJ,2}));
        propRE2(i,SJ) = nansum(re_block{i,SJ,2})/(nansum(le_block{i,SJ,2}) + nansum(re_block{i,SJ,2}) + nansum(be_block{i,SJ,2}));
        propBE2(i,SJ) = nansum(be_block{i,SJ,2})/(nansum(le_block{i,SJ,2}) + nansum(re_block{i,SJ,2}) + nansum(be_block{i,SJ,2}));
        
        % now RE-LE/RE+LE, after Dieter, Sy & Blake Vis Res submission
        SED_run(i,SJ,2) = (propRE2(i,SJ)-propLE2(i,SJ))/(propRE2(i,SJ)+propLE2(i,SJ));
    end
end

%% now average across runs
SED_overall = zeros(13,size(subjIDs,1));

for SJ = 1:size(subjIDs,1)
    for L = 1:13 % locations
        a = [SED_run(L,SJ,1) SED_run(L,SJ,2)];
        SED_overall(L,SJ) = nansum(a)/(2-sum(isnan(a)));
    end
end

%% concatenate run1 and run2 data for test/retest plot
run1_all = []; run2_all = [];
for SJ = 1:size(subjIDs,1)
    rel(:,SJ) = abs(SED_run(:,SJ,1)-SED_run(:,SJ,2));
    
    if SJ ~= 6 && SJ ~= 11 % exclude unreliable subjects, to match figure in paper
        run1_all(size(run1_all,2)+1:size(run1_all,2)+13) = SED_run(:,SJ,1);
        run2_all(size(run2_all,2)+1:size(run2_all,2)+13) = SED_run(:,SJ,2);
    end
end
figure;
plot(run1_all,run2_all,'ko')
[r,p] = corr(transpose(run1_all),transpose(run2_all))
axis([-1 1 -1 1])

%% difference metric for establishing reliability
count = 1;
for SJ = 1:size(subjIDs,1)
    rel(:,count) = abs(SED_run(:,SJ,1)-SED_run(:,SJ,2));
    count = count + 1;
end
med_rel = median(rel,1);
edges = 0:0.05:1;
rel_hist = histc(med_rel,edges);
rel_hist = rel_hist/sum(rel_hist);
figure
bar(edges,rel_hist)
axis([0 1 0 .4])
